#pragma once
#include <iostream>
#include <iomanip>
#include <string>

void add_two_numbers();
int read_number();
void write_answer(int x);
void convert_char_to_ascii();
void print_type_size_bytes();
void bubble_sort_print_demo();

template <typename T>
struct TypeName
{
    static const char *Get()
    {
        return typeid(T).name();
    }
};
template <>
struct TypeName<std::string>
{
    static const char *Get()
    {
        return "s";
    }
};

template <class T>
void bubble_sort(int size, T *a)
{
    for (int i = 0; i < size; i++)
    {
        for (int j = 0; j < size - 1 - i; j++)
        {
            if (a[j] > a[j + 1])
            {
                T temp{a[j]};
                a[j] = a[j + 1];
                a[j + 1] = temp;
            }
        }
    }
};

template <typename T>
void bubble_sort_print(int size, T *a)
{
    std::cout << std::left; // left justify output
    std::cout << "unsorted " << TypeName<T>::Get() << std::setw(10) << " Array: ";
    for (int i = 0; i < size; i++)
        std::cout << a[i] << ", ";
    std::cout << "\n";
    bubble_sort(size, a);
    std::cout << "sorted " << TypeName<T>::Get() << std::setw(12) << " Array: ";
    for (int i = 0; i < size; i++)
        std::cout << a[i] << ", ";
    std::cout << "\n\n";
};